'''
Created on 3 nov. 2018

@author: invite

'''
import random
import Conf


class Box:
    '''
    classdocs
    '''


    def __init__(self,** keys):
        
        random.seed()
        self.isVisible=True
        self.drivethrough=False
        
        if 'c' in keys :
            self.c=keys['c']
        else:
            self.c=None
            
        if 'sx' in keys :
            self.sx=int(keys['sx'])
        else:
            self.sx=random.randint(Conf.blocSizeXmin,Conf.blocSizeXmax)
            
        if 'sy' in keys :
            self.sy=int(keys['sy'])
        else:
            self.sy=random.randint(Conf.blocSizeYmin,Conf.blocSizeYmax)
            
        if 'sz' in keys :
            self.sz=int(keys['sz'])
        else:
            self.sz=random.randint(Conf.blocSizeZmin,Conf.blocSizeZmax)
        
        if 'px' in keys :
            self.px=int(keys['px'])
        else:
            self.px=random.randint(0,2*Conf.worldSize)
            
            
        if 'py' in keys :
            self.py=int(keys['py'])
        else:
            self.py=random.randint(0,2*Conf.worldSize)
            
            
        if 'pz' in keys :
            self.pz=int(keys['pz'])
        else:
            self.pz=0
            
        if 'color' in keys :
            self.color=keys['color']
        else:
            self.color=None
            
        if 'shootthrough' in keys :
            self.shootthrough=keys['shootthrough']
        else:
            self.shootthrough=False
            
        if 'matref' in keys :
            self.matref=keys['matref']
        else:
            self.matref=None
        
        if 'protected' in keys :
            self.protected=keys['protected']
        else:
            self.protected=False
            
        if 'type' in keys :
            self.type=keys['type']
        elif random.random() > Conf.ratioPyramid:
            self.type="box"
        else:
            self.type="pyramid"

            
        if 'rotation' in keys :
            self.rotation=keys['rotation']
        else:    
            random.seed()
            self.rotation=int(360*random.random())

    def getSurface(self):
        return self.sx*self.sy
    
    def cloneCtf(self):
        
        if self.rotation is None:
            self.rotation=0
            
        r=self.rotation+180
        if r>=360:
            r-=360
        
        px,py=self.symetrieAxiale(self.px, self.py)
        
        c=Box(sx=self.sx,sy=self.sy,sz=self.sz,px=px,py=py,pz=self.pz,shootthrough=self.shootthrough, \
              color=self.color,protected=self.protected,type=self.type,rotation=r,c=self.c)
        return c
    
        
    def draw(self):
        
        if self.type=="pyramid" :
            if random.random() <= Conf.ratioMeshpyr:
                self.drivethrough=True
                self.color="0.133333 0.545098 0.133333 0.7"
                self.type="meshpyr"
            
        #if self.isVisible:
        print (self.type)
        print ("  position "+str(self.px-Conf.worldSize)+" "+str(self.py-Conf.worldSize)+" "+str(self.pz))     
        print ("  size "+str(self.sx)+" "+str(self.sy)+" "+str(self.sz))
        print ("  rotation "+str(self.rotation))


        if self.matref != None:
            print ("   matref "+self.matref)
                
        if self.color != None:
            print ("  color "+self.color)
            
        if self.shootthrough is True:
            print("  shootthrough")
                
        if self.drivethrough is True:
            print("   drivethrough")
            
        
    
        print ("end")
        """
        else:
            print (self.type)
            print ("  position "+str(self.px)+" "+str(self.py)+" "+str(self.pz))     
            print ("  size "+str(self.sx)+" "+str(self.sy)+" "+str(self.sz))
            print ("  rotation "+str(self.rotation))


            if self.matref != None:
                print ("   matref "+self.matref)
                
            if self.shootthrough is True:
                print("shootthrough")

                        
            
            print("y- color red")
            print("y+ color red")
            print("x- color red")
            print("x+ color red")
            
                
            print ("end")    
        """
    
    def getC(self):
        return self.c
    
    def getDriveThrough(self):
        return self.drivethrough
    
    def getPx(self):
        return self.px
    
    def getPy(self):
        return self.py
                
    def getPz(self):
        return self.pz  
                    
    def getRotation(self):
        return self.rotation  
    
    def getSx(self):
        return self.sx
    
    def getSy(self):
        return self.sy
            
    def getSz(self):
        return self.sz
    
    def getType(self):
        return self.type

    
    def getProtected(self):    
        return self.protected 
         
             
    def isVisible(self):
        return self.isVisible
    
    def symetrieAxiale(self,x,y):
        if x>Conf.worldSize:
            px=Conf.worldSize-(x-Conf.worldSize)
        else:
            px=Conf.worldSize+(Conf.worldSize-x)
            
        if y>Conf.worldSize:
            py=Conf.worldSize-(y-Conf.worldSize)
        else:
            py=Conf.worldSize+(Conf.worldSize-y)
            
        return px,py
         
    def setIsVisible(self,b):
        self.isVisible=b
        
    def setIsProtected(self,b):
        self.protected=b
        
    def setDriveThrough(self,b):
        self.drivethrough=b
        
    def setMatRef(self,matref):
        self.matref=matref
        
    def setPosx(self,px):
        self.px=int(px)
    
    def setPosy(self,py):
        self.py=int(py)
            
    def setPosz(self,pz):
        self.pz=int(pz)
    
    def setProtected(self,bool):    
        self.protected=bool

    def setSizeX(self,sx):
        self.sx=int(sx)
    
    def setSizeY(self,sy):
        self.sy=int(sy)
            
    def setSizeZ(self,sz):
        self.sz=int(sz)
        
    def setRotation(self,r):
        self.rotation=int(r)
    
    def setType(self,t):
        self.type=t
        
    def xShift(self,x):
        self.px=self.px+int(x)
        
    def yShift(self,y):
        self.py=self.py+int(y)
        
    def zShift(self,z):
        self.pz=self.pz+int(z)
        