'''
Created on 4 nov. 2018

@author: invite
'''
from math import cos
from math import sin
from math import pi
import Conf
import random
from StepBloc import StepBloc


class GroupCircle(object):
    '''
    classdocs
    '''


    def __init__(self, collection, ** keys):
        
        self.c=collection.getList()
        self.shX=Conf.worldSize
        self.shY=Conf.worldSize
        self.shZ=0
        #self.posxmax=40
        #self.posymax=40
    
       
        if 'rayon' in keys :
            self.r=keys['rayon']
        else:
            print ("circle need rayon")
            exit()

        if 'name' in keys :
            self.name=keys['name']
        else:
            self.name="unknown"
                
        #if 'posxmax' in keys :
        #    self.posxmax=keys['posxmax']
        #if 'posymax' in keys :
        #    self.posymax=keys['posymax']
        if 'shX' in keys :
            self.shX=keys['shX']
        if 'shY' in keys :
            self.shY=keys['shY']
            
        self.genCircle()
   
        self.shift()
       
    def genCircle(self):       
        random.seed
            
        #print("# ******* circle "+self.name+" *******")    
        angle=(2*pi)/len(self.c)
        
        if len(self.c) !=0:
            if self.shX==0 and self.shY==0:
                # generation d un cercle au centre
                angle=pi/len(self.c)
            else:
                angle=(pi+(random.random()*pi))/len(self.c)
            #pour un cercle complet    
            #else:
            #    angle=(2*pi)/len(self.c)
            
        #print (angle);
        a=0
        for o in self.c:
            o.setPosx(self.r*cos(a))
            o.setPosy(self.r*sin(a))
            a=a+angle
            
            # step bloc
            if o.getType()!="pyramid" and o.getType()!="meshpyr":
                if random.random() < Conf.ratioStepBloc :
                    for b in StepBloc(o).getList():
                        self.c.append(b)
    
    def draw(self):           
        
        print("# ******* circle "+self.name+" *******")
        for o in self.c:
            o.draw()
            
    def getList(self):
        return self.c

    def getName(self):
        return self.name

    
    def len(self):
        return len(self.c)
       
        
    def setShift(self,x,y,z):
        self.shX=x
        self.shY=y
        self.shZ=z
        
    def shift(self):
        for o in self.c:
            o.xShift(self.shX)
            o.yShift(self.shY)
        