'''
Created on 27 nov. 2018

@author: invite
'''

import random
import math
import Conf
from Box import Box
import Material

class Montagne(object):
    '''
    classdocs
    '''
    """
    montagneNbBlocMin=10
    montagneNbBlocMax=40
    montagneSizeXmin=10
    montagneSizeYmin=10
    montagneSizeZmin=10
    montagneSizeXmax=30
    montagneSizeYmax=30
    montagneSizeZmax=60
    """
    def __init__(self, ** keys):
     
        random.seed()
        
        self.c=[]
        self.matrice=[]
        self.surface=0
        #self.shX=0
        #self.shY=0
        #self.shZ=0
        self.rotation=0
        self.color="1 0.72549 0.058824 1"
        
        if 'name' in keys :
            self.name=keys['name']
        else:
            self.name="unknown"

        if 'hight' in keys :
            self.hight=keys['hight']
        else:
            print("Montagne need hight")
            exit(1)
            
        if 'step' in keys :
            self.step=keys['step']
        else:
            print("Montagne need step")
            exit(1)

        if 'sizeX' in keys :
            self.sizeX=keys['sizeX']
        else:
            print("Montagne need sizeX")
            exit(1)
            
        if 'sizeY' in keys :
            self.sizeY=keys['sizeY']
        else:
            print("Montagne need sizeY")
            exit(1)
        
        if 'montagneSizeX' in keys :
            self.montagneSizeX=keys['montagneSizeX']
        else:
            print("Montagne need montagneSizeX")
            exit(1)
        
        if 'montagneSizeY' in keys :
            self.montagneSizeY=keys['montagneSizeY']
        else:
            print("Montagne need montagneSizeY")
            exit(1)
        
        if 'centerX' in keys :
            self.centerX=keys['centerX']
        else:
            print("Montagne need centerX")
            exit(1)
        
        if 'centerY' in keys :
            self.centerY=keys['centerY']
        else:
            print("Montagne need centerY")
            exit(1)
               
        matriceSide=round(Conf.worldSize/((Conf.montagneBlocSizeXmin+Conf.montagneBlocSizeYmin)/2))
        
        for x in range(0,matriceSide):
            self.matrice.append([])
            for y in range(0,matriceSide):
                self.matrice[x].append(None)
                    
        
        # the top of the  hill
        x=round(matriceSide/2)
        y=round(matriceSide/2)
        self.matrice[x][y]=Box(sx=self.sizeX,sy=self.sizeY,sz=self.hight,type="meshbox",shootthrough=True,color=self.color,px=self.centerX,py=self.centerY,rotation=self.rotation,c=self.c)
        
        # list of the new blocs
        list=[]
        list.append([x,y])   
        
        
        
        #nbStep=1
        #nbBlocsToAddPerBloc=random.randint(1,3)
        sizeZ=self.hight-self.step
        i=1
        #print("montagneSize X Y :"+str(self.montagneSizeX)+"/"+str(self.montagneSizeY))
        
        while sizeZ > 3:
            #print("mountain step: "+str(sizeZ))
            
            #k coef de croissance ...
            k=i**2
            nbBlocsToAdd=random.randint(round(k/2),k)
            i+=1
            
            while nbBlocsToAdd > 0:
                
                # on choisi un bloc au hasard dans la montagne
                indexMax=len(list)-1
                #print("indexMax "+str(indexMax))
                j=random.randint(0,indexMax)
                
                x,y=list[j]
                o=self.matrice[x][y]
                px=o.getPx()
                py=o.getPy()
                nbBlocsToAddPerBloc=random.randint(0,3)
                
                while nbBlocsToAddPerBloc > 0:
                    #if nbBlocsToAdd <=0:
                    #    raise BreakIt
                    #print("nbBlocsToAddPerBloc: "+str(nbBlocsToAddPerBloc))
                    if self.matrice[x-1][y+1] == None:
                        self.matrice[x-1][y+1]=Box(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=True,color=self.color,px=px-(2*self.sizeX),py=py+(2*self.sizeY),rotation=self.rotation,c=self.c)
                        list.append([x-1,y+1])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x-1][y] == None:
                        self.matrice[x-1][y]=Box(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=True,color=self.color,px=px-(2*self.sizeX),py=py,rotation=self.rotation,c=self.c)
                        list.append([x-1,y])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x-1][y-1] == None:
                        self.matrice[x-1][y-1]=Box(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=True,color=self.color,px=px-(2*self.sizeX),py=py-(2*self.sizeY),rotation=self.rotation,c=self.c)
                        list.append([x-1,y-1])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x][y-1] == None:
                        self.matrice[x][y-1]=Box(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=True,color=self.color,px=px,py=py-(2*self.sizeY),rotation=self.rotation,c=self.c)
                        list.append([x,y-1])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x+1][y-1] == None:
                        self.matrice[x+1][y-1]=Box(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=True,color=self.color,px=px+(2*self.sizeX),py=py-(2*self.sizeY),rotation=self.rotation,c=self.c)
                        list.append([x+1,y-1])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x+1][y] == None:
                        self.matrice[x+1][y]=Box(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=True,color=self.color,px=px+(2*self.sizeX),py=py,rotation=self.rotation,c=self.c)
                        list.append([x+1,y])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x+1][y+1] == None:
                        self.matrice[x+1][y+1]=Box(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=True,color=self.color,px=px+(2*self.sizeX),py=py+(2*self.sizeY),rotation=self.rotation,c=self.c)
                        list.append([x+1,y+1])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    if self.matrice[x][y+1] == None:
                        self.matrice[x][y+1]=Box(sx=self.sizeX,sy=self.sizeY,sz=sizeZ,type="meshbox",shootthrough=True,color=self.color,px=px,py=py+(2*self.sizeY),rotation=self.rotation,c=self.c)
                        list.append([x,y+1])
                        nbBlocsToAddPerBloc -= 1
                        nbBlocsToAdd -= 1
                        self.surface+= self.sizeX*self.sizeY
                        continue
                    
                    del list[j]
                    break
                #list.remove([x,y])
                
                
            sizeZ -= self.step
                
            
                     
       
       
        for x in range(0,matriceSide):
            for y in range(0,matriceSide):
                if self.matrice[x][y] != None:
                    self.c.append(self.matrice[x][y])
                
    def draw(self):           
        
        print("#montagne "+self.name+ "- nb blocs: "+str(self.len()))
        #print("#montagne "+self.name+ "- surface totale: "+str(self.posxmax*self.posymax))
        for o in self.c:
            o.draw()
        
    def getList(self):
        return self.c
    
    def getName(self):
        return self.name


    def getSurface(self):
        return self.surface
    
    def len(self):
        return len(self.c)
       
    def shift(self):
        for o in self.c:
            o.xShift(self.shX)
            o.yShift(self.shY)
            
        
    def getPosxmax(self):
        return self.posxmax
        
    def getPosymax(self):
        return self.posymax
           
    def setShift(self,x,y,z):
        self.shX=x
        self.shY=y
        self.shZ=z
        
    def setPosxmax(self,x):
        self.posxmax=x
        
    def setPosymax(self,y):
        self.posymax=y        