'''
Created on 23 janv. 2019

@author: invite
'''

import random
import Conf


class Base(object):
    '''
    classdocs
    '''


    def __init__(self,** keys):
        '''
        Constructor
        '''
        random.seed()
        self.c=[]
       
        if 'color' in keys :
            self.color=keys['color']
        else:
            print("erreur: base need color")
            exit(1)
        
        
        if 'sx' in keys :
            self.sx=keys['sx']
        else:
            self.sx=random.randint(20,40)
                 
        if 'sy' in keys :
            self.sy=keys['sy']
        else:
            self.sy=random.randint(20,40)
            
        if 'sz' in keys :
            self.sz=keys['sz']
        else:
            self.sz=1
            
            
        if 'px' in keys :
            self.px=keys['px']
        else:
            if self.sx>(Conf.worldSize/3):
                self.px=self.sx
            else:
                self.px=random.randint(self.sx,(Conf.worldSize*2)-self.sx)
        
        
        if 'py' in keys :
            self.py=keys['py']
        else:
            if self.sy>(Conf.worldSize/3):
                self.py=self.sy
            else:
                self.py=random.randint(self.sy,int(Conf.worldSize/3))

        
        if 'pz' in keys :
            self.pz=keys['pz']
        else:
            #self.level=random.randint(0,2)
            self.level=2
            self.pz=(self.level*Conf.stepHight)-self.sz
            
        if 'rotation' in keys :
            self.rotation=keys['rotation']
        else:
            self.rotation=random.random()*360
            #self.rotation=0
            

            
            
        
    def draw(self):
        
        if self.getPy()<0:
            y=-10
        else:
            y=10
            
        px,py=self.translate(self.px,self.py)
        print ("base")
        print ("  position "+str(px)+" "+str(py)+" "+str(self.pz))     
        print ("  size "+str(self.sx)+" "+str(self.sy)+" "+str(self.sz))
        print ("  rotation "+str(self.rotation))
        print ("  color "+str(self.color))
        print ("end")
        print ("zone")
        print ("  position "+str(y)+" 0 0")     
        print ("  size 5 5 0")
        print ("  safety "+str(self.color))
        print ("end")
        
        
    def getLevel(self):
        return self.level
 
            
    
    def getPx(self):
        return self.px
    
    def getPy(self):
        return self.py
            
    def getPz(self):
        return self.pz
    
    def getRotation(self):
        return self.rotation
    
    def getSx(self):
        return self.sx
    
    def getSy(self):
        return self.sy
            
    def getSz(self):
        return self.sz
    
        
    def translate(self,x,y):
        return  x-Conf.worldSize,y-Conf.worldSize
