'''
Created on 4 nov. 2018

@author: invite
'''
import random

class Forest(object):
    '''
    classdocs
    '''
    def __init__(self, collection, ** keys):
     
        random.seed()
        self.c=collection.getList()
        self.shX=0
        self.shY=0
        self.shZ=0


        if 'name' in keys :
            self.name=keys['name']
        else:
            self.name="unknown"

            
        if 'posxmax' in keys :
            self.posxmax=keys['posxmax']
        else:
            print("forest need posxmax")
            exit()
            
        if 'posymax' in keys :
            self.posymax=keys['posymax']
        else:
            print("forest need posymax")
            exit()
            
        if 'shX' in keys :
            self.shX=keys['shX']
        if 'shY' in keys :
            self.shY=keys['shY']
                    
        for o in self.c:
            o.setPosx(random.randint(0,self.posxmax))
            o.setPosy(random.randint(0,self.posymax))
            
        if self.shX != 0 or self.shY !=0:
            self.shift()
            
            
        
       
       
    #def draw(self):           
        
    #    print("#forest "+self.name+ "- nb blocs: "+str(self.len()))
        #print("#forest "+self.name+ "- surface totale: "+str(self.posxmax*self.posymax))
    #    for o in self.c:
    #        o.draw()
        
    def getList(self):
        return self.c
    
    def getName(self):
        return self.name

    
    def len(self):
        return len(self.c)
       
    def shift(self):
        for o in self.c:
            o.xShift(self.shX)
            o.yShift(self.shY)
        

        
    def getPosxmax(self):
        return self.posxmax
        
    def getPosymax(self):
        return self.posymax
           
    def setShift(self,x,y,z):
        self.shX=x
        self.shY=y
        self.shZ=z
        
    def setPosxmax(self,x):
        self.posxmax=x
        
    def setPosymax(self,y):
        self.posymax=y