'''
Created on 14 nov. 2018

@author: invite
'''

import Conf
import random
import math

class Line(object):
    '''
    classdocs
    '''
    def __init__(self, collection, ** keys):
     
        random.seed()
        
        self.c=collection.getList()
        self.shX=0
        self.shY=0
        self.shZ=0
        self.posxmax=40
        self.posymax=40

        if 'name' in keys :
            self.name=keys['name']
        else:
            self.name="unknown"

            
        if 'lineLong' in keys :
            self.lineLong=keys['lineLong']
        else:
            print("line need lineLong")
            exit()
            
            
        if 'shX' in keys :
            self.shX=keys['shX']
        if 'shY' in keys :
            self.shY=keys['shY']
                    
                    
        self.lineRotation=random.uniform(0,2*math.pi)
        deltaX=self.lineLong*math.cos(self.lineRotation)
        deltaY=self.lineLong*math.sin(self.lineRotation)
        
        startX=random.uniform(0,(2*Conf.worldSize)-math.fabs(deltaX))
        startY=random.uniform(0+math.fabs(deltaY),(2*Conf.worldSize)-math.fabs(deltaY))
    
        if len(self.c) != 0:
            stepx=deltaX/len(self.c)
            stepy=deltaY/len(self.c)
        i=0
        for j in range(0,int(len(self.c)/2),2):
            self.c[j].setPosx(startX+(i*stepx))
            self.c[j+1].setPosx(startX+(-i*stepx))
            self.c[j].setPosy(startY+(i*stepy))
            self.c[j+1].setPosy(startY+(-i*stepy))
            
            i+=1
            
       
    def draw(self):           
        
        for o in self.c:
            o.draw()
        
    def getList(self):
        return self.c

    def getName(self):
        return self.name

    
    def len(self):
        return len(self.c)
       
    def getPosxmax(self):
        return self.posxmax
        
    def getPosymax(self):
        return self.posymax
        
    def setPosxmax(self,x):
        self.posxmax=x
        
    def setPosymax(self,y):
        self.posymax=y     