'''
Created on 6 nov. 2018

@author: invite
'''
import math
from Box import Box
import Conf
import random
from math import cos
from math import sin
from math import tan
from Collection import Collection
from FlagGapFunction import FlagGapFunction

class MainCollection(object):
    '''
    classdocs
    '''

    def __init__(self, ** keys):
        self.c=[]
        self.matrice=[]
        #self.matgap=[]
        self.cpt=0
        self.isBloc=False
        #self.surface=0
        max=(2*Conf.worldSize)
        
        for x in range(max):
            self.matrice.append([])
            for y in range(max):
                 self.matrice[x].append(False)
                 self.matrice[x][y]=[]
                
        if 'surfaceLimite' in keys :
            self.surfaceLimite=keys['surfaceLimite']
                        
    def addBloc(self,b):  
        self.c.append(b)
        
    def addCollection(self,c):
        #self.c.append(c)
        for o in c.getList():
            self.c.append(o)
            self.loadInMatrice(o)
        
        symCollection=self.symCtf(c.getList())
        for o in symCollection.getList():
            self.c.append(o)
            self.loadInMatrice(o)
        

    def addCollectionAndOverride(self,c):
        for o in c.getList():
            self.addBloc(o)
            self.overrideInMatrice(o)
        
        symCollection=self.symCtf(c.getList())
        for o in symCollection.getList():
            self.addBloc(o)
            self.overrideInMatrice(o)
                
    def addToMatriceFunc(self,x,y,o):
        max=(2*Conf.worldSize)
        
        if x>=0 and x<max:
            if y>=0 and y<max:
                self.matrice[x][y].append(o)
                
    def fillArea(self,sx,sy,px,py):
        
        if len(self.matrice) == 0:
            print ("#fillArea need matrice initialised")
            exit()
            
        surface=0
        
        xMin=px-sx+Conf.worldSize
        xMax=px+sx+Conf.worldSize
        yMin=py-sy+Conf.worldSize
        yMax=py+sy+Conf.worldSize
        for x in range(xMin,xMax):
            for y in range(yMin,yMax):
                if len(self.matrice[x][y])==0:
                    self.addBloc(Box(px=x,py=y,sz=40,c=self.c))
        return 
    
    def cleanArea(self,sx,sy,px,py,rotation):
        
        # old code
        #if len(self.matrice) == 0:
        #    print ("#cleanArea need matrice initialised")
        #    exit()
            
        #surface=0
        
        #xMin=px-sx
        #xMax=px+sx
        #yMin=py-sy
        #yMax=py+sy
        #for x in range(xMin,xMax):
        #    for y in range(yMin,yMax):
        #        for o in self.matrice[x][y]:
        #            if not o.getProtected():
        #                surface+=o.getSurface()
        #                self.c.remove(o)
        #                self.removeBlocFromMatrice(o)
                    
        #return surface
        o=Box(sx=sx,sy=sy,px=px,py=py,rotation=rotation)
        self.boxToMatrice(self.cleanAreaFunc, o)
        
    def cleanAreaFunc(self,x,y,o):
        max=(2*Conf.worldSize)
        
        if x>=0 and x<max:
            if y>=0 and y<max:
                
                        
                listref=[]
                for o in self.matrice[x][y]:
                    listref.append(o)
                    
                for o in listref:
                    self.removeBlocFromMatrice(o)
                    self.c.remove(o)
                return
            
        

    def makeBridgeCentraleSym(self):
        
        for o in self.c:
            if o.getSizeX()>5 and o.getSizeY()>5 and o.getSizeZ()>7 and o.getSizeZ()<17:
                y=10
                z=1
                x=math.sqrt(o.getPosx()**2+o.getPosy()**2)
                rotation=(180*math.atan(o.getPosy()/o.getPosx())) / math.pi
                b=Box(sx=x,sy=y,sz=z,px=0,py=0,pz=(o.getSizeZ()-z),rotation=rotation,c=self.c)
                b.setProtected(True)
                o.setProtected(True)
                self.c.append(b)
                
                return
                 

    def draw(self):
        
        for o in self.c:
           o.draw()
           
           
    def getC(self):
        return self.c
        
    def gapCount(self,x,y):
        
        #***
        # count distance between bloc
        # enable on ctf to avoid flag drop in inacessible gap
        # if gap < Conf.gap :
        #  bloc deleted delete from main collection and matrice
        #***
        
        #***
        # pas de bloc
        #***
        #if len(self.matrice[x][y])==0 or self.testAllAreDriveThrought(self.matrice[x][y]):
        if len(self.matrice[x][y])==0:
            if self.isBloc is True:
                self.cpt=1
                self.isBloc=False
            else:
                self.cpt+=1
        #***
        # bloc
        #***    
        else:
            if self.isBloc is False:
                self.isBloc=True
                if self.cpt<Conf.gap:
                    #self.matgap[x][y]=True
                    
                    for o in self.matrice[x][y]:
                        self.c.remove(o)
                        if self.c.count(o)!=0:
                            print("maincollection : gapcount same object remains")
                            exit(1) 
                        
                    self.removeCollectionFromMatrice(x,y)
                    self.bloc=False
                    self.cpt+=1
                        #o.setIsVisible(False)
                        #o.setDriveThrough(True)
                        #o.setMatRef("drivethrough")
                        #if o.getType() == "box":
                        #    o.setType("meshbox")
                        #elif o.getType() == "pyramid":
                        #    o.setType("meshpyr")
                        
                        #try:
                           # o.getC().remove(o)
                        #except ValueError:
                            #pass
                        #del o
                        #self.matrice[x][y].remove(o)
        
                        
    def checkSmallGap(self):
        
        #***
        # parcour de la  map 
        # pour chaque point on lance self.gapCount
        #***
        
        #print("#main collection before checkSmallGap: "+str(len(self.getC())))
        
        max=(2*Conf.worldSize)
        
        for x in range(0,max):
            self.isBloc=False
            self.cpt=0
            for y in range(Conf.worldSize,max):
                self.gapCount(x, y)
            self.isBloc=False
            self.cpt=0
            for y in range(Conf.worldSize,0,-1):
                self.gapCount(x, y)
                                
        
        for y in range(0,max):
            bloc=False
            cpt=0
            for x in range(Conf.worldSize,max):     
                self.gapCount(x, y)
            self.isBloc=False
            self.cpt=0
            for x in range(Conf.worldSize,0,-1):     
                self.gapCount(x, y)
                
        #print("#main collection after checkSmallGap: "+str(len(self.getC())))
        # on bouche les trous
        #for x in range(0,max):
        #    for y in range(0,max):
        #        if self.matgap[x][y]:
        #            self.addBloc(Box(sx=1,sy=1,sz=20,px=x,py=y,type="box"))
                                

        
        
    def loadInMatrice(self,o):  
        self.boxToMatrice(self.addToMatriceFunc, o)
            

    def overrideInMatrice(self,o):
        self.boxToMatrice(self.overrideInMatriceFunc, o)
        
    def overrideInMatriceFunc(self,x,y,o):
        max=(2*Conf.worldSize)
        
        if x>=0 and x<max:
            if y>=0 and y<max:
                for o in self.matrice[x][y]:
                    self.removeFromMatriceFunc(x,y,o)
                self.addToMatriceFunc(x, y, o)
        return
    
    def removeFromMatriceFunc(self,x,y,o):
        
        max=(2*Conf.worldSize)
        
        if x>=0 and x<max:
            if y>=0 and y<max:
                
                try:
                    self.matrice[x][y].remove(o)
                except ValueError:
                    pass
        
        
    def removeCollectionFromMatrice(self,X,Y):
        
        listref=[]
        for o in self.matrice[X][Y]:
            listref.append(o)
            
        for o in listref:
            self.removeBlocFromMatrice(o)
        return
                 
    def removeBlocFromMatrice(self,o):
        self.boxToMatrice(self.removeFromMatriceFunc, o)
                
    def symCtf(self,c):
        symCollection=Collection(nb=0,name="sym")
        for o in c:
            symCollection.add(o.cloneCtf())
        return symCollection
                    
    def toString(self):
        max=(2*Conf.worldSize)
         
        for x in range(0,max):
            print("")
            print("#",end = '')
            for y in range(0,max):
        
                if len(self.matrice[x][y])==0:
                    print(".",end = '')
                else:
                    print("x",end = '')
                    
                    
    def boxToMatrice(self,func,o):
        
        #****
        # parcour l ensemble des point l objet dans la matrice
        # et y applique la fonction func
        #***
        
        f=FlagGapFunction(o)
        a=f.getAngle()
    
        if  a<90 :
            for x in range(f.getXmin(),f.getXmax()):                
                
                if f.getDeltaX()< f.getDeltaXX():
                    if x < f.getXmin()+f.getDeltaX():
                        for y in range(f.wSide(x),f.nSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)
                       
                    elif x < f.getXmax()-f.getDeltaX():
                        for y in range(f.sSide(x),f.nSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)
                
                    else:
                        for y in range(f.sSide(x),f.eSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                            
                
                if f.getDeltaX()> f.getDeltaXX():
                    
                    if x < f.getXmin()+f.getDeltaXX():
                        #print( "4+ x: "+str(x)+"/// ymin: "+str(f.wSide(x))+"/ ymax: "+str(f.nSide(x)))
                        for y in range(f.wSide(x),f.nSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                
                    elif x < f.getXmax()-f.getDeltaXX():
                        #print( "5+ x: "+str(x)+"/// ymin: "+str(f.wSide(x))+"/ ymax: "+str(f.eSide(x)))
                        for y in range(f.wSide(x),f.eSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                
                    else:
                        #print( "6+ x: "+str(x)+"/// ymin: "+str(f.sSide(x))+"/ ymax: "+str(f.nSide(x)))
                        for y in range(f.sSide(x),f.eSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                            
                

        elif a>=90:
            #print ( str(f.getXmin())+"**X**"+str(f.getXmax()))
            for x in range(f.getXmin(),f.getXmax()):  
                
                if f.getDeltaX()< f.getDeltaXX():              
               
                    if x < f.getXmin()+f.getDeltaX():                                   
                        #print( "1+ x: "+str(x)+"/// ymin: "+str(f.nSide(x))+"/ ymax: "+str(f.eSide(x)))
                        for y in range(f.nSide(x),f.eSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                        
                    elif x < f.getXmax()-f.getDeltaX():
                        #print( "2+ x: "+str(x)+"/// ymin: "+str(f.nSide(x))+"/ ymax: "+str(f.sSide(x)))
                        #print( str ("1  "+str(f.nSide(x)))+"///"+str(f.sSide(x)))
                        for y in range(f.nSide(x),f.sSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                        
                    else:
                        #print( "3+ x: "+str(x)+"/// ymin: "+str(f.wSide(x))+"/ ymax: "+str(f.sSide(x)))
                        #print( str ("2  "+str(f.nSide(x)))+"///"+str(f.wSide(x)))
                        for y in range(f.wSide(x),f.sSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)


                                
                if f.getDeltaX()> f.getDeltaXX():              

                    #print( "*** deltaX: "+str(f.getDeltaX())+"/ deltaXX: "+str(f.getDeltaXX()))
                    if x < f.getXmin()+f.getDeltaXX():
                        #print( "4+ x: "+str(x)+"/// ymin: "+str(f.nSide(x))+"/ ymax: "+str(f.eSide(x)))
                            
                        for y in range(f.nSide(x),f.eSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)


                        
                    elif x < f.getXmax()-f.getDeltaXX():
                        #print( "5+ x: "+str(x)+"/// ymin: "+str(f.wSide(x))+"/ ymax: "+str(f.eSide(x)))
                        #print( str ("1  "+str(f.nSide(x)))+"///"+str(f.sSide(x)))
                        for y in range(f.wSide(x),f.eSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)


                        
                    else:
                        #print( str ("2  "+str(f.nSide(x)))+"///"+str(f.wSide(x)))
                        #print( "6+ x: "+str(x)+"/// ymin: "+str(f.wSide(x))+"/ ymax: "+str(f.sSide(x)))
                        for y in range(f.wSide(x),f.sSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                         
                    
        else:
            print("erreur flagGapFunction a:"+str(a))
            exit(1)                           
            