'''
Created on 4 nov. 2018

@author: invite
'''
import random
import math
from MainCollection import MainCollection
from Collection import Collection
from GroupCircle import GroupCircle
from Forest import Forest
from Collection import Collection
from Material import Material
from Box import Box
from Line import Line
from Montagne import Montagne
import Conf
from math import fabs
from Base import Base
from BaseWay import BaseWay
from StepBloc import StepBloc


'''
world : x from 0 to 2*Conf.worldSize
        y from 0 to Conf.worldSize
        axial symetrie axe y=Conf.worldsize

'''

class World(object):

    def __init__(self,** keys):
        
        random.seed()
        
        self.cLine=0
        self.cCircle=0
        self.cBigbloc=0
        self.cBigPyra=0
        self.cCollection=0
        self.cForest=0
        self.cMontagne=0
        
        self.remplissage=random.uniform(Conf.remplissageMin,Conf.remplissageMax)
        print("#remplissage :"+str(self.remplissage))
        
        #base1
        self.base1=Base(color=Conf.color1)
        # base2
        p2x,p2y=self.symetrieAxiale(self.base1.getPx(),self.base1.getPy())
        self.base2=Base(color=Conf.color2,px=p2x,py=p2y,pz=self.base1.getPz(),sx=self.base1.getSx(), \
                        sy=self.base1.getSy(),sz=self.base1.getSz(),rotation=self.base1.getRotation())
        
        
            
        #diviser par 4 car ctf et group repete 2X 
        # conf.worldsize car   2x*2y !=  x*y
        self.surfaceCircles=0
        self.surface=0
        self.surfaceLimite=(self.remplissage*(Conf.worldSize**2))/2
        self.surfaceRoad=0

        
        self.M=MainCollection(surfaceLimite=self.surfaceLimite)
        self.M2=MainCollection()
        #self.M1=MainCollection(surfaceLimite=self.surfaceLimite)
        
        # generation differente en fonction de la position de la base
        diag_world=math.sqrt(2)*Conf.worldSize
        if self.base1.getPx() > Conf.worldSize:
            x=self.base1.getPx()-Conf.worldSize
        else:
            x=Conf.worldSize-self.base1.getPx()
        if self.base1.getPy() > Conf.worldSize:
            y=self.base1.getPy()-Conf.worldSize
        else:
            y=Conf.worldSize-self.base1.getPy()
        diag_base=math.sqrt((x**2)+(y**2))
        n=diag_world/diag_base
        #CHANGER ICI POUR TESTER
        #n=2
        if n >=1.5:
            #print()
            #self.cotecote()
        #elif n >= 1.5
            #self.test()
            self.middle()
        else:
            self.opposite()
        
        
        
        #self.M.symCtf()
        #self.M.loadCollectionInMatrice(self.M.getC)
        
        #***
        # way up to the base
        #***

        
        self.M2.addCollection(BaseWay(self.base1))
        self.M2.draw()
        
        
        #***
        # base
        #***
        self.M.cleanArea(self.base1.getSx(),self.base1.getSy(),self.base1.getPx(),self.base1.getPy(),self.base1.getRotation())
        self.base1.draw()
        self.M.cleanArea(self.base2.getSx(),self.base2.getSy(),self.base2.getPx(),self.base2.getPy(),self.base2.getRotation())
        self.base2.draw()
        #self.M.cleanArea(50,50,0,0)
        #self.M.fillArea(100,100,300,300)

        #***
        # road
        #***
        #print("/!\road not finished")
        #exit(1)
        roadWide=random.randint(Conf.roadWideMin,Conf.roadWideMax)
        roadLength=random.randint(Conf.roadLengthMin,Conf.roadLengthMax)
        max=round((2*Conf.worldSize)-roadLength)
        
        while Conf.roadSurface > self.surfaceRoad :
            rotation=random.randint(0,360)
            
            if random.randint(0,1):
                px=random.randint(0,max)
                py=random.randint(0,max)
            else:
                px=0
                py=0
            
            if random.randint(0,1):
                sx=roadWide
                sy=roadLength
            else:
                sx=roadLength
                sy=roadWide
        
            
            
            self.M.cleanArea(sx,sy,px,py,rotation)
            px,py=self.symetrieAxiale(px, py)
            self.M.cleanArea(sx,sy,px,py,rotation)
            
            self.surfaceRoad=sx*sy*2
        
        #***
        #* acces to high bloc
        #***
        
        for b in self.M.getC():
            if b.getSz()> Conf.stepHight and b.getSz() < 2*Conf.stepHight and b.getSx()>8 and b.getSy()>8:
                if random.random() < 0.2:
                    self.M.addCollection(StepBloc(b))
        
        
        #***
        # main
        #***
        
        
        self.M.checkSmallGap()
        self.M.draw()

        
        #self.draw() 
        #self.M.toString()
        print("***[ FIN ]***")
                    
    def cotecote(self):
        
        i=random.randint(1,2)
        if i==1:
            wallMaterial=Material(name="wall",color=[0,0,0,0.3])
            rotation=((180*math.atan(self.base1.getPy()/self.base1.getPx())) / math.pi)+90
            wall=Box(type="meshbox",shootthrough=True,matref="wall",sx=Conf.wallSize,sy=2,sz=80,rotation=rotation,px=Conf.worldSize,py=Conf.worldSize,protected=True)        
            wallMaterial.draw()
            wall.draw()
        if i==2:
            step=random.randint(Conf.montagneStepMin,Conf.montagneStepMax)
        
            montagneSizeX=random.randint(Conf.montagneSizeMin,Conf.montagneSizeMax)
            montagneSizeY=random.randint(Conf.montagneSizeMin,Conf.montagneSizeMax)
            
            sizeX=random.randint(Conf.montagneBlocSizeXmin,Conf.montagneBlocSizeXmax)
            sizeY=random.randint(Conf.montagneBlocSizeYmin,Conf.montagneBlocSizeYmax)
            
            hight1=(montagneSizeX/sizeX)*step
            hight2=(montagneSizeY/sizeY)*step
            
            if hight1 > hight2:
                hight=hight2
            else:
                hight=hight1
            
            rotation=self.randRotation()
            m=Montagne(hight=hight,step=step,sizeX=sizeX,sizeY=sizeY,centerX=0,centerY=0, \
            montagneSizeX=montagneSizeX,montagneSizeY=montagneSizeY,rotation=rotation,name="montagne"+str(self.cMontagne))
            self.M.addCollectionAndOverride(m)
            

        self.opposite()

        return
    
    def middle(self):
        
        print("#middle")

        self.opposite()
        return
    
    def opposite(self):
        
        random.seed()
        #self.addBigBlocCollection()
        #self.addBigPyra()
        
        while self.surface < self.surfaceLimite:
            #print("surface "+str(self.surface))
            building=random.random()*100
            #building=70
            #protected=random.random()*100
            
            #self.addMontagne()
            #self.addBigBlocCollection()
            
            if building < 35:
                self.addForest()
                # self.addCircle()

            elif building < 50:
                self.addCollection()
            
                
            elif building < 75:
                if self.cMontagne >= 1 :
                    continue
                self.addMontagne()
                #self.addForest()
                    
            elif building < 101:
                self.addCircle()
                #if self.cMontagne <1:
                 #   self.addMontagne()
                #
            #elif building < 95:
            #    if self.cBigbloc >= 1 :
            #        continue
            #    self.addBigBlocCollection()
                
            #elif building < 101:
            # BUG ON BIG PYRA : pb with M.addBloc function, doesnt load in matrice
            #    self.addBigPyra()
                    
            else:
                print ("probleme base")
                exit()
            
        print ("#*** surface limite = "+str(self.surfaceLimite))
        print ("#*** surface generee = "+str(self.surface))
        #****************
         # auto clean
        #****************
        surfaceToClean=Conf.ratioToCleanMax*(Conf.worldSize**2)
        s=0
        
        
    def addCollection(self):
        
        random.seed()
        nb=random.randint(Conf.nbBlocMaxPerCollection/10,Conf.nbBlocMaxPerCollection)
        
        rotation=self.randRotation()

        protected=False
        
        type=self.randType()
            
        #****************
        #*taille fixe
        #****************
        if random.random() < Conf.ratioTailleFixe:
            sizeX=random.randint(1,Conf.collectionSizeXmax)
            sizeY=random.randint(1,Conf.collectionSizeYmax)
            sizeZ=random.randint(1,Conf.collectionSizeZmax)
            
            c=Collection(nb=nb,protected=protected,type=type,sizeX=sizeX,sizeY=sizeY,sizeZ=sizeZ,rotation=rotation, \
                         name="collection"+str(self.cCollection))
            
        #****************
        #*taille variable
        #****************    
        else:
            sizeXmax=random.randint(Conf.collectionSizeXmin,Conf.collectionSizeXmax)
            sizeYmax=random.randint(Conf.collectionSizeYmin,Conf.collectionSizeXmax)
            sizeZmax=random.randint(Conf.collectionSizeZmin,Conf.collectionSizeXmax)
            
            c=Collection(nb=nb,protected=protected,type=type,sizeXmin=Conf.collectionSizeXmin, \
                         sizeYmin=Conf.collectionSizeYmin,sizeZmin=Conf.collectionSizeZmin,sizeXmax=sizeXmax, \
                         sizeYmax=sizeYmax,sizeZmax=sizeZmax,rotation=rotation,name="collection"+str(self.cCollection))
                
        self.M.addCollection(c)
        self.surface+=c.getSurface()/2
        #print ("#collection added - s = "+str(c.getSurface()))
        self.cCollection+=1
        
    def addBigBlocCollection(self):

        # TODO
        # clean area or protected, add collection and tele on it
        random.seed()
        nb=random.randint(1,Conf.nbBigBlocMax)
        
        rotation=self.randRotation()

        protected=False
            
        #****************
        #*taille fixe
        #****************
        #if random.random() < Conf.ratioTailleFixe:
        #    sizeX=random.randint(1,Conf.bigBlocSizeXmax)
        #    sizeY=random.randint(1,Conf.bigBlocSizeYmax)
        #    sizeZ=random.randint(1,Conf.bigBlocSizeZmax)
            
        #    c=Collection(nb=nb,protected=protected,type="box",sizeX=sizeX,sizeY=sizeY,sizeZ=sizeZ,rotation=rotation, \
        #                 name="big bloc"+str(self.cBigbloc))
            
        #****************
        #*taille variable
        #****************    
        #else:
        sizeXmax=random.randint(Conf.bigBlocSizeXmin,Conf.bigBlocSizeXmax)
        sizeYmax=random.randint(Conf.bigBlocSizeYmin,Conf.bigBlocSizeYmax)
        sizeZmax=random.randint(Conf.bigBlocSizeZmin,Conf.bigBlocSizeZmax)
        
        c=Collection(nb=nb,protected=protected,type="box",sizeXmin=Conf.bigBlocSizeXmin, \
                     sizeYmin=Conf.bigBlocSizeYmin,sizeZmin=Conf.bigBlocSizeZmin,sizeXmax=sizeXmax, \
                     sizeYmax=sizeYmax,sizeZmax=sizeZmax,rotation=rotation, \
                     name="big bloc"+str(self.cBigbloc))
        # step bloc
        for o in c.getList():
            for b in StepBloc(o).getList():
                        c.append(b)
            
        self.M.addCollection(c)
        # on reduit l importance des big blocs
        self.surface+=c.getSurface()
        #print ("#big blocs added - s = "+str(c.getSurface()))
        self.cBigbloc+=1
        
    def addBigPyra(self):
        
        # BUG ON BIG PYRA : pb with M.addBloc function, doesnt load in matrice
        rotation=self.randRotation()
        protected=False

        #****************
        #*taille variable
        #****************    
        #else:
        sx=random.randint(Conf.bigPyraSizeXmin,Conf.bigPyraSizeXmax)
        sy=random.randint(Conf.bigPyraSizeYmin,Conf.bigPyraSizeYmax)
        sz=random.randint(Conf.bigPyraSizeZmin,Conf.bigPyraSizeZmax)
        
            
        #self.M.addBloc(Box(sx=sx,sy=sy,sz=sz,type="pyramid",rotation=rotation))
        # on reduit l importance des big blocs
        self.surface+=sx*sy
        #print ("#big blocs added - s = "+str(c.getSurface()))
        self.cBigPyra+=1
        
            
    def addForest(self):
        
        random.seed()
        surface=random.randint(0,Conf.ratioForestSize*(Conf.worldSize**2))
        posxmax=random.randint(Conf.forestLongMin, Conf.worldSize)
        posymax=round(surface/posxmax)
        if posymax > Conf.worldSize:
            posymax = Conf.worldSize - 1
        
        densite=random.uniform(Conf.densiteForestMin,Conf.densiteForestMax)
        
        #*******************************
        #* generation d une collection
        rotation=self.randRotation()
        protected=False
        type=self.randType()
        
        #*taille fixe
        
        if random.random() < Conf.ratioTailleFixe:
                    
            sizeX=random.randint(Conf.forestSizeXmin,Conf.forestSizeXmax)
            #on evite les rectrangles trop long, pour eviter les trou a drapeau
            sizeY=random.randint(Conf.forestSizeYmin,Conf.forestSizeYmax)
            #if sizeY > 2*sizeX:
            #    sizeY=2*sizeX
            sizeZ=random.randint(Conf.forestSizeZmin,Conf.forestSizeZmax)
            
            nb=round( (posxmax*posymax*densite)/( sizeX * sizeY ) )
        
            
            c=Collection(nb=nb,protected=protected,type=type,sizeX=sizeX,sizeY=sizeY,sizeZ=sizeZ,rotation=rotation)
            
            #*taille variable
            
        else:
    
            sizeXmax=random.randint(1,Conf.forestSizeXmax)
            sizeYmax=random.randint(1,Conf.forestSizeYmax)
            sizeZmax=random.randint(1,Conf.forestSizeZmax)
            
            nb=int((posxmax*posymax*densite)/ (((sizeXmax+Conf.forestSizeXmin)/2)*((sizeYmax+Conf.forestSizeYmin)/2)) )
            
            c=Collection(nb=nb,protected=protected,type=type,sizeXmin=Conf.forestSizeXmin, \
                         sizeYmin=Conf.forestSizeYmin,sizeZmin=Conf.forestSizeZmin, \
                         sizeXmax=sizeXmax,sizeYmax=sizeYmax,sizeZmax=sizeZmax,rotation=rotation,square=True)
        
        
        #print("X"+str(posxmax)+"/"+str((2*Conf.worldSize)-posxmax))
        #shX=fabs(random.randint(0,(2*Conf.worldSize)-(2*posxmax)))
        #print("Y"+str(posymax)+"/"+str((2*Conf.worldSize)-posymax))
        #shY=fabs(random.randint(0,(2*Conf.worldSize)-(2*posymax)))
        shX=random.randint(posxmax,(2*Conf.worldSize)-posxmax)
        shY=random.randint(posymax,(2*Conf.worldSize)-posymax)               
        #self.M.addCollection(Forest(Collection(protected=True)))
        self.M.addCollection(Forest(c,shX=shX,shY=shY,posxmax=posxmax,posymax=posymax,name="forest"+str(self.cForest)))
        
        self.surface+=c.getSurface()
        #print("#forest"+str(self.cForest)+" densite: "+str(densite)+" - c surface: "+str(c.getSurface()))
            
        self.cForest+=1
        #print ("#forest added - s = "+str(c.getSurface()))
            
    def addMontagne(self):
        
        random.seed()
        
        #*******************************
        #* generation d une collection
        rotation=self.randRotation()
        protected=False
       # type=self.randType()
                
        #*taille 
        step=random.randint(Conf.montagneStepMin,Conf.montagneStepMax)
        
        montagneSizeX=random.randint(Conf.montagneSizeMin,Conf.montagneSizeMax)
        montagneSizeY=random.randint(Conf.montagneSizeMin,Conf.montagneSizeMax)
        
        sizeX=random.randint(Conf.montagneBlocSizeXmin,Conf.montagneBlocSizeXmax)
        sizeY=random.randint(Conf.montagneBlocSizeYmin,Conf.montagneBlocSizeYmax)
        
        hight1=(montagneSizeX/sizeX)*step
        hight2=(montagneSizeY/sizeY)*step
        
        if hight1 > hight2:
            hight=hight2
        else:
            hight=hight1
        
        centerX=random.randint(round(montagneSizeX/2),(2*Conf.worldSize)-round(montagneSizeX/2))
        centerY=random.randint(round(montagneSizeY/2),(2*Conf.worldSize)-round(montagneSizeY/2))
        
        rotation=self.randRotation()
        
        #print("#hight="+str(hight)+"/step="+str(step)+"sizeX="+str(sizeX)+"sizeY="+str(sizeY)+"centerX"+str(centerX)+"centerY="+str(centerY)+ \
                                     #"montagneSizeX="+str(montagneSizeX)+"montagneSizeY="+str(montagneSizeY))
        
        m=Montagne(hight=hight,step=step,sizeX=sizeX,sizeY=sizeY,centerX=centerX,centerY=centerY, \
            montagneSizeX=montagneSizeX,montagneSizeY=montagneSizeY,rotation=rotation,name="montagne"+str(self.cMontagne))
        self.M.addCollectionAndOverride(m)
        
        #on divise la surface de la montagne par 2!
        self.surface+=m.getSurface()/2
            
        self.cMontagne+=1
            
    def addCircle(self):
        
        random.seed()
        
        rayon=random.randint(Conf.circleRayonMin,Conf.worldSize)
               
        #*******************************
        #* generation d une collection
        #*******************************
        nbMax=(2*math.pi*rayon)/(math.sqrt(2)*(Conf.circleSizeXmax+Conf.circleSizeYmax-Conf.circleSizeXmin-Conf.circleSizeYmin)/2)
                
        nb=random.randint(1,int(nbMax))
        if nb > Conf.nbBlocMaxPerCircle:
            nb=int((Conf.nbBlocMaxPerCircle*2)/3)
        
        #posxmax=self.worldSize*random.random()
        #posymax=self.worldSize*random.random()
        
        #****************
        #* rotation
        #****************

        rotation=self.randRotation()

        protected=False
        
        type=self.randType()
        
        #****************
        #*taille fixe
        #****************
        if random.random() < Conf.ratioTailleFixe:
            
            sizeX=random.randint(Conf.circleSizeXmin,Conf.circleSizeXmax)
            sizeY=random.randint(Conf.circleSizeYmin,Conf.circleSizeYmax)
            sizeZ=random.uniform(Conf.circleSizeZmin,Conf.circleSizeZmax)
            
            c=Collection(nb=nb,protected=protected,type=type,sizeX=sizeX,sizeY=sizeY,sizeZ=sizeZ,rotation=rotation)
            
        #****************
        #*taille variable
        #****************    
        else:
            sizeXmax=random.randint(Conf.circleSizeXmin,Conf.circleSizeXmax)
            sizeYmax=random.randint(Conf.circleSizeYmin,Conf.circleSizeXmax)
            sizeZmax=random.randint(Conf.circleSizeZmin,Conf.circleSizeXmax)
                        
            c=Collection(nb=nb,protected=protected,type=type, \
                         sizeXmin=Conf.circleSizeXmin,sizeYmin=Conf.circleSizeYmin,sizeZmin=Conf.circleSizeZmin, \
                         sizeXmax=sizeXmax,sizeYmax=sizeYmax,sizeZmax=sizeZmax, \
                         rotation=rotation)


        if Conf.ratioCenterCircle < random.random():
            shX=random.randint(rayon,(Conf.worldSize*2)-rayon)
            shY=random.randint(rayon,(Conf.worldSize*2)-rayon)
        else:
            shX=Conf.worldSize
            shY=Conf.worldSize
        
        self.M.addCollection(GroupCircle(c,shX=shX,shY=shY,rayon=rayon,name="circle"+str(self.cCircle)))   

        if c.getSurface() > (math.pi*rayon*rayon):
            s=math.pi*rayon*rayon
        else:
            s=c.getSurface()
            
        self.surfaceCircles+=s
        self.surface+=s
        
        self.cCircle+=1
        #print ("#circle added - s = "+str(s))
 
    def addLine(self):
        
        random.seed()
        
        long=random.randint(Conf.lineLongMin,Conf.lineLongMax)
        densite=random.uniform(Conf.lineDensiteMin,Conf.lineDensiteMax)
                       
        #*******************************
        #* generation d une collection

        rotation=self.randRotation()

        protected=False
        
        type=self.randType()
        
        #****************
        #*taille fixe
        #****************
            
        sizeX=random.randint(Conf.lineSizeXmin,Conf.lineSizeXmax)
        sizeY=random.randint(Conf.lineSizeYmin,Conf.lineSizeYmax)
        sizeZ=random.randint(Conf.lineSizeZmin,Conf.lineSizeZmax)
        
        #nb=round( (long*densite)/ ((sizeX+sizeY)/2) )
        nb=round( (long*densite)/ sizeX)
        print("line nb "+str(nb))
        # voir distribution de la ligne
        if nb % 2 !=0:
            nb-=1
        
        c=Collection(nb=nb,protected=protected,type=type,sizeX=sizeX,sizeY=sizeY,sizeZ=sizeZ,rotation=rotation)

        self.M.addCollection(Line(c,lineLong=long,name="line"+str(self.cLine)))

        self.surface+=c.getSurface()
        self.cLine+=1
        #print ("#line added - s = "+str(c.getSurface()))
            
   # def draw(self):
        

        
        #******************
        # on dessine les bases au debut
        # ainsi on evite qu un bloc se superpose a la base 
        # cf methode drawB1 et 2
        #######################

    #    return
        

    
    def randRotation(self):
        random.seed()
        if random.random() < Conf.ratioRotationRandom :
            rotation=0
        else:
            rotation=random.randint(0,360)
            #if random.random() < 0.5:
            #    rotation=0
            #else:
            #    rotation=45
                
        return rotation
    
    def randType(self):
        random.seed()
        #****************
        #*pyra or box
        #****************
        if random.random() < Conf.ratioRandomCollection:
            type="random"
        elif random.random()< Conf.ratioPyramid:
            type="pyramid"
        else:
            type="box"
        
        return type
    


    def setColor(self,color):
         self.color=color
         

    
            
    def symetrieAxiale(self,x,y):
        if x>Conf.worldSize:
            px=Conf.worldSize-(x-Conf.worldSize)
        else:
            px=Conf.worldSize+(Conf.worldSize-x)
            
        if y>Conf.worldSize:
            py=Conf.worldSize-(y-Conf.worldSize)
        else:
            py=Conf.worldSize+(Conf.worldSize-y)
            
        return px,py

            
    def ztest(self):
        
            #self.addLine()
            #self.addCircle()
            #self.addCircle()
            #for i in range(0,5):
            #self.addLine()
            #self.addMontagne()
            #self.addForest()
            #self.addForest()
            #self.addCollection()
            #self.addCollection()
            #self.addCollection()
            #self.addCollection()
            #self.addCollection()
            #self.opposite()
            #c=Collection(nb=0,name="test")
            #c.add(Box(sx=4,sy=4,sz=16,px=-110,py=10,rotation=0,c=c.getC()))
            #c.add(Box(sx=4,sy=4,sz=16,px=-110,py=19,rotation=0,c=c.getC()))
            
            #c.add(Box(sx=4,sy=4,sz=15,px=10,py=10,rotation=0,c=c.getC()))
            #c.add(Box(sx=4,sy=4,sz=15,px=10,py=20,rotation=0,c=c.getC()))
            #self.M.addCollection(c)
            
            
            
            ###############
            #
            #
            # ADD ,c=self.c
            #
            #################
            #c.add(Box(sx=4,sy=4,sz=15,px=-85,py=-70,rotation=170))
            #c.add(Box(sx=4,sy=4,sz=15,px=-75,py=-65,rotation=150))
            
            #c.add(Box(sx=4,sy=4,sz=15,px=75,py=-90,rotation=90))
            #c.add(Box(sx=4,sy=4,sz=15,px=60,py=-95,rotation=95))
            #c.add(Box(sx=4,sy=4,sz=15,px=60,py=-80,rotation=100))
            #c.add(Box(sx=4,sy=4,sz=15,px=60,py=-65,rotation=105))
            #c.add(Box(sx=4,sy=4,sz=15,px=60,py=-50,rotation=110))
            #c.add(Box(sx=4,sy=4,sz=15,px=60,py=-35,rotation=115))
            #c.add(Box(sx=4,sy=4,sz=15,px=60,py=-20,rotation=120))
            #c.add(Box(sx=4,sy=4,sz=15,px=60,py=-5,rotation=125))
            #c.add(Box(sx=4,sy=4,sz=15,px=60,py=10,rotation=130))
            
            #c.add(Box(sx=4,sy=4,sz=15,px=60,py=25,rotation=135))
            #c.add(Box(sx=4,sy=4,sz=15,px=60,py=40,rotation=140))
            #c.add(Box(sx=4,sy=4,sz=15,px=60,py=55,rotation=145))
            #c.add(Box(sx=4,sy=4,sz=15,px=60,py=70,rotation=150))
            
            #c.add(Box(sx=4,sy=4,sz=15,px=45,py=80,rotation=155))
            #c.add(Box(sx=4,sy=4,sz=15,px=45,py=65,rotation=160))
            #c.add(Box(sx=4,sy=4,sz=15,px=45,py=50,rotation=165))
            #c.add(Box(sx=4,sy=4,sz=15,px=45,py=35,rotation=170))
            #"c.add(Box(sx=4,sy=4,sz=15,px=45,py=20,rotation=175))
            #c.add(Box(sx=4,sy=4,sz=15,px=45,py=5,rotation=180))
            
            #c.add(Box(sx=4,sy=4,sz=15,px=-90,py=90,rotation=0))
            #c.add(Box(sx=4,sy=4,sz=15,px=90,py=-95,rotation=0))
            #c.add(Box(sx=4,sy=4,sz=15,px=90,py=-80,rotation=5))
            #c.add(Box(sx=4,sy=4,sz=15,px=90,py=-65,rotation=10))
            #c.add(Box(sx=4,sy=4,sz=15,px=90,py=-50,rotation=15))
            #c.add(Box(sx=4,sy=4,sz=15,px=90,py=-35,rotation=20))
            #c.add(Box(sx=4,sy=4,sz=15,px=90,py=-20,rotation=25))
            #c.add(Box(sx=4,sy=4,sz=15,px=90,py=-5,rotation=30))
            #c.add(Box(sx=4,sy=4,sz=15,px=90,py=10,rotation=35))
            #c.add(Box(sx=4,sy=4,sz=15,px=90,py=25,rotation=40))
            #c.add(Box(sx=4,sy=4,sz=15,px=90,py=40,rotation=45))
            #c.add(Box(sx=4,sy=4,sz=15,px=90,py=55,rotation=50))
            #c.add(Box(sx=4,sy=4,sz=15,px=90,py=75,rotation=55))
            #c.add(Box(sx=4,sy=4,sz=15,px=75,py=85,rotation=60))
            #c.add(Box(sx=4,sy=4,sz=15,px=75,py=65,rotation=65))
            #c.add(Box(sx=4,sy=4,sz=15,px=75,py=50,rotation=70))
            #c.add(Box(sx=4,sy=4,sz=15,px=75,py=35,rotation=75))
            #c.add(Box(sx=4,sy=4,sz=15,px=75,py=20,rotation=80))
            #c.add(Box(sx=4,sy=4,sz=15,px=75,py=5,rotation=85))
            #c.add(Box(sx=4,sy=4,sz=15,px=90,py=-95,rotation=90))
            
            #self.M.addCollection(c)
            
            #self.addForest()
            #self.addForest()
        return